UNIT mTTurtleWelt;

interface

//--------------------  ggf Uses-Liste anpassen !  --------------------
uses mTWeltBildManager, mTTurtle, Graphics;

type
   TTurtleWelt = CLASS

     // weitere Attribute
     private
        xmax : real;
        xmin : real;
        ymax : real;
        ymin : real;
        Leinwand : TCanvas;
        T : TTurtle;
        WBM : TWeltBildManager;

     //Objektbeziehungen:
        // hatTTurtle : TTurtle;
        // hatTWeltBildManager : TWeltBildManager;

     // weitere Methoden
     private
        procedure zeichneTurtle(x,y,w:real);
     public
        constructor Create(xmin,xmax,ymin,ymax:real; Canvas:TCanvas; umax,vmax:integer);
        procedure bk(schritte:real);
        procedure fd(schritte:real);
        procedure ht;
        procedure lt(winkel:real);
        procedure pd;
        procedure pu;
        procedure rt(winkel:real);
        procedure SetPos(x,y:real);
        procedure SetW(winkel:real);
        procedure st;
        procedure arc(r,alpha : real; d : shortint);
        function GetW : real;
        function GetX : real;
        function GetY : real;
        destructor Destroy;
   end;

implementation

//+---------------------------------------------------------------------
//|         TTurtleWelt: Methodendefinition
//+---------------------------------------------------------------------

//-------- st (public) -------------------------------------------------
procedure TTurtleWelt.st;
begin
  if not T.GetSichtbar then
  begin
    T.SetSichtbar(true);
    zeichneTurtle(T.GetX,T.GetY,T.GetW);
  end;
end;

//-------- ht (public) -------------------------------------------------
procedure TTurtleWelt.ht;
begin
  if T.GetSichtbar then
  begin
    T.SetSichtbar(false);
    zeichneTurtle(T.GetX,T.GetY,T.GetW);
  end;
end;

//-------- zeichneTurtle (private) -------------------------------------
procedure TTurtleWelt.zeichneTurtle(x,y,w:real);
const
  r  = 30;
  wi = 150;
var
  xl,yl,xr,yr : real;
  u,v         : integer;
  alterModus  : TPenMode;
begin
  xl := x + r*cos((w+wi)/180*pi);
  yl := y + r*sin((w+wi)/180*pi);
  xr := x + r*cos((w-wi)/180*pi);
  yr := y + r*sin((w-wi)/180*pi);
  u := WBM.ut(xr); v := WBM.vt(yr);
  alterModus := Leinwand.Pen.Mode; Leinwand.Pen.Mode := pmNotXor;
  Leinwand.MoveTo(u,v);
  u := WBM.ut(x); v := WBM.vt(y);
  Leinwand.LineTo(u,v);
  u := WBM.ut(xl); v := WBM.vt(yl);
  Leinwand.MoveTo(u,v);
  u := WBM.ut(x); v := WBM.vt(y);
  Leinwand.LineTo(u,v);
  Leinwand.Pen.Mode := alterModus;
end;

//-------- Create (public) ---------------------------------------------
constructor TTurtleWelt.Create(xmin,xmax,ymin,ymax:real; Canvas:TCanvas; umax,vmax:integer);
begin
  inherited Create;
  WBM := TWeltBildManager.Create;
  WBM.berechneKoeffizienten(xmin,xmax,ymin,ymax,umax,vmax);
  Leinwand := Canvas;
  T := TTurtle.Create;
  T.setPos(0,0); T.SetW(0);
  T.SetSichtbar(false); T.SetStiftunten(true);
end;

//-------- bk (public) -------------------------------------------------
procedure TTurtleWelt.bk(schritte:real);
begin
  fd(-schritte);
end;

//-------- fd (public) -------------------------------------------------
procedure TTurtleWelt.fd(schritte:real);
var
  u,v : integer;
begin
  if T.GetSichtbar then zeichneTurtle(T.GetX,T.GetY,T.GetW);
  if T.GetStiftunten then
  begin
    u := WBM.ut(T.GetX); v := WBM.vt(T.GetY);
    Leinwand.MoveTo(u,v);
  end;
  T.fd(schritte);
  if T.GetStiftunten then
  begin
    u := WBM.ut(T.GetX); v := WBM.vt(T.GetY);
    Leinwand.LineTo(u,v);
  end;
  if T.GetSichtbar then zeichneTurtle(T.GetX,T.GetY,T.GetW);
end;

//-------- lt (public) -------------------------------------------------
procedure TTurtleWelt.lt(winkel:real);
begin
  if T.GetSichtbar then zeichneTurtle(T.GetX,T.GetY,T.GetW);
  T.lt(winkel);
  if T.GetSichtbar then zeichneTurtle(T.GetX,T.GetY,T.GetW);
end;

//-------- pd (public) -------------------------------------------------
procedure TTurtleWelt.pd;
begin
  T.SetStiftunten(true);
end;

//-------- pu (public) -------------------------------------------------
procedure TTurtleWelt.pu;
begin
  T.SetStiftunten(false);
end;

//-------- rt (public) -------------------------------------------------
procedure TTurtleWelt.rt(winkel:real);
begin
  if T.GetSichtbar then zeichneTurtle(T.GetX,T.GetY,T.GetW);
  T.rt(winkel);
  if T.GetSichtbar then zeichneTurtle(T.GetX,T.GetY,T.GetW);
end;

//-------- SetPos (public) ---------------------------------------------
procedure TTurtleWelt.SetPos(x,y:real);
begin
  if T.GetSichtbar then zeichneTurtle(T.GetX,T.GetY,T.GetW);
  T.setPos(x,y);
  if T.GetSichtbar then zeichneTurtle(T.GetX,T.GetY,T.GetW);
end;

//-------- SetW (public) -----------------------------------------------
procedure TTurtleWelt.SetW(winkel:real);
begin
  if T.GetSichtbar then zeichneTurtle(T.GetX,T.GetY,T.GetW);
  T.SetW(winkel);
  if T.GetSichtbar then zeichneTurtle(T.GetX,T.GetY,T.GetW);
end;

procedure TTurtleWelt.arc(r,alpha : real; d : shortint);
var
  n,i : integer;
  w,a : real;
begin
  n := round(abs(alpha));
  // n := 3; //DEBUG
  w := abs(alpha)/(2*n); a := 2*r* sin(w/180*pi);
  if d*alpha > 0 then rt(w) else lt(w);
  for i := 1 to n-1 do
  begin
    if alpha > 0 then fd(a) else bk(a);
    if d*alpha > 0 then rt(2*w) else lt(2*w);
  end;
  if alpha > 0 then fd(a) else bk(a);
  if d*alpha > 0 then rt(w) else lt(w);
end;

//-------- GetW (public) -----------------------------------------------
function TTurtleWelt.GetW : real;
begin
  result := T.GetW;
end;

//-------- GetX (public) -----------------------------------------------
function TTurtleWelt.GetX : real;
begin
  result := T.GetX;
end;

//-------- GetY (public) -----------------------------------------------
function TTurtleWelt.GetY : real;
begin
  result := T.GetY;
end;

//-------- Destroy (public) --------------------------------------------
destructor TTurtleWelt.Destroy;
begin
  T.Free;
  WBM.Free;
  inherited destroy;
end;

end.
