UNIT mTWeltBildManager;

interface


//--------------------  ggf Uses-Liste einfgen !  --------------------
//uses ....;

type
   TWeltBildManager = CLASS

     // weitere Attribute
     private
        Fa : real;
        Fb : real;
        Fc : real;
        Fd : real;

     // weitere Methoden
     public
        procedure berechneKoeffizienten(xmin,xmax,ymin,ymax,umax,vmax:real);
        function ut(x:real) : integer;
        function vt(y:real) : integer;
        function xt(u:integer) : real;
        function yt(v:integer) : real;

   end;

implementation

//+---------------------------------------------------------------------
//|         TWeltBildManager: Methodendefinition 
//+---------------------------------------------------------------------

//-------- berechneKoeffizienten (public) ------------------------------
procedure TWeltBildManager.berechneKoeffizienten(xmin,xmax,ymin,ymax,umax,vmax:real);
begin
  Fa := umax/(xmax-xmin); Fb := -Fa*xmin;
  Fc := vmax/(ymin-ymax); Fd := -Fc*ymax;
end;

//-------- ut (public) -------------------------------------------------
function TWeltBildManager.ut(x:real) : integer;
begin
  result := round(Fa*x+Fb);
end;

//-------- vt (public) -------------------------------------------------
function TWeltBildManager.vt(y:real) : integer;
begin
  result := round(Fc*y+Fd);
end;

//-------- xt (public) -------------------------------------------------
function TWeltBildManager.xt(u:integer) : real;
begin
  result := (u - Fb)/Fa;
end;

//-------- yt (public) -------------------------------------------------
function TWeltBildManager.yt(v:integer) : real;
begin
  result := (v - Fd)/Fc;
end;

end.
